#Uvjetna programska grananja i programske petlje

#Uvjetna grananja u R-u su slicna su onima iz vecine 
#drugih programskih jezika:

########################################################

#  IF - ELSE

# sintaksa: 
# if (cond) statement
# if (cond) statement1 else statement2

# ako je uvijet cond istinit (TRUE) izvrsava se statement1 
# u protivnom izvrsava se statement2

x <- 10

if (x > 20) {
    print("x je veci od 20")
} else print("x je manji od 20")


######################################################

# ELSEIF

# sintaksa: ifelse(cond, statement1, statement2)

# statement1 se izvrsava ako je cond TRUE
# inace se izvrsava statement2

bodovi<-10

ifelse(bodovi > 5, print("Prosao"), print("Pao"))

rezultat <- ifelse (bodovi > 5, "Prosao", "Pao")
rezultat

##########################################################
# kratak intermezzo: logicki operatori u R-u

# ! x            negacija od x
# x & y          logicki "i" ("and") - po elemetima vektora 
# x && y         logicki "i" ("and") - uzima samo prvi element
# x | y          logicki "ili" ("or") - po elemetima vektora
# x || y         logicki "ili" ("or") - uzima samo prvi element
# xor(x, y)      "exclusive OR"

# isTRUE(x)

help("!")

# primjer 

prvi=TRUE;
drugi=FALSE;

if (prvi & drugi){
  print("sve je istina")
  } else print("bar nesto nije istina")

if (prvi | drugi){
  print("bar nesto je istina")
  } else print("nista nije istina")

##########################################################


# REPEAT
#ponavlja neki izraz ili niz izraza sve dok se ne dogodi 
#prekid. (Ako ga ne bude, vi ste u beskonacnoj petlji):

x <- 1
repeat {
    if (x > 3) 
        break else {
        print(x)
        x <- x + 1
    }
}

## [1] 1
## [1] 2
## [1] 3

########################################################

# WHILE petlja
# sintaksa:    while (cond) statement

x <- 4
while (x < 7) {
    print(x);
    x <- x + 1
}

## [1] 4
## [1] 5
## [1] 6

#Za razliku od '*repeat*' petlje koja se mora izvrsiti 
#barem jedanput, '*while*' petlja se ne mora niti jednom 
#izvrsiti, ako uvjet na pocetku nije zadovoljen.

######################################################
# FOR petlja


# programska petlja za iteraciju 
#kroz svaki element vektora ili liste:

# sintaksa:    for (var in seq) statement
# var poprima vrijednosti iz seq (uzima jednu po jednu
# vrijednost iz seq) i sa svakom novom vrijednosti var
# izvrsava se izraz statement

x <- 0
for (x in 8:12) print(x)

## [1] 8
## [1] 9
## [1] 10
## [1] 11
## [1] 12

for (i in c(3,6,9)) {k<-i-3; print(k)}

#[1] 0
#[1] 3
#[1] 6


#######################################

# SWITCH

# sintaksa:
# switch(izraz, ....)
# obzirom na izraz, bira jedan od ponudjenih odgovora iz ....

help("switch")

# nabolje se ilustrira na primjerima:

# primjer 1: 

switch("ljut",
veseo = "Drako mi je da si sretan/sretna",
zabrinut = "Ne brini",
tuzan = "Razveseli se",
ljut = "Smiri se"
)

# primjer 2:

osjecaji <- c("tuzan", "zabrinut")

for (i in osjecaji)
print(
switch(i,
veseo = "Drago mi je da si sretan/sretna",
zabrinut = "Ne brini",
tuzan = "Razveseli se",
ljut = "Smiri se"
)
)

